/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.adding;

/**
 *
 * @author apple
 */
public class Vector implements Operand{
    private double[] value;

    public Vector(double[] value) {
        this.value = new double[value.length];
        System.arraycopy(value, 0, this.value, 0, value.length);
    }

    public double[] getValue() {
        double[] value = new double[this.value.length];
        System.arraycopy(this.value, 0, value, 0, this.value.length);
        return value;
    }

    public Operand add(Operand value) throws NumericException {
        Vector operand,result;
        
        if (value == null) throw new IllegalArgumentException("Parametr value je null");
        if (!(value instanceof Vector)) throw new TypeMismatchException("Parametr neni vektor");
        operand = (Vector) value;
        if (this.value.length != operand.getValue().length)
            throw new InvalidDimensionException("Nesouhlasi dimenze vektoroveho prostoru");
        
        double doubleResult[] = new double[this.value.length];
        for (int i = 0; i < this.value.length; i++) {
            doubleResult[i] = this.value[i] + operand.getValue()[i];
        }
        
        result = new Vector(doubleResult);
        
        return result;
       
    }

    public Operand sub(Operand value) throws NumericException {
        Vector operand,result;
        
        if (value == null) throw new IllegalArgumentException("Parametr value je null");
        if (!(value instanceof Vector)) throw new TypeMismatchException("Parametr neni vektor");
        operand = (Vector) value;
        if (this.value.length != operand.getValue().length)
            throw new InvalidDimensionException("Nesouhlasi dimenze vektoroveho prostoru");
        
        double doubleResult[] = new double[this.value.length];
        for (int i = 0; i < this.value.length; i++) {
            doubleResult[i] = this.value[i] - operand.getValue()[i];
        }
        
        result = new Vector(doubleResult);
        
        return result;
    }

    @Override
    public String toString() {
        StringBuilder desc = new StringBuilder("[");
        for(int i = 0; i < this.value.length ; i++ ){
            desc.append(this.value[i]);
            if( i < this.value.length -1 ){
                desc.append(", ");
            }
        }
        desc.append("]");
        
        return desc.toString();
    }
    
    
    
}
